import os

class CoxResult:
    def __init__( self ):
        self.keys = []

        self.wald = []
        self.features = {}

        self.ewald = []
        self.efeatures = {}

class PLE:
    pass

class WALD:
    pass

def ParseCoxrOutput( output ):
    ples = []
    robusts = []

    for line in output:
        fields = line.split()
        if len( fields ) == 0:
            continue
        if "##PLE_FEATURE" == fields[0]:
            aPle = PLE()
            aPle.key = fields[1]
            aPle.coef = fields[2]
            aPle.exp_coef = fields[3]
            aPle.se_coef = fields[4]
            aPle.p = fields[5]
            ples.append( aPle )
        if "##FEATURE" == fields[0]:
            aPle = PLE()
            aPle.key = fields[1]
            aPle.coef = fields[2]
            aPle.exp_coef = fields[3]
            aPle.se_coef = fields[4]
            aPle.p = fields[5]
            robusts.append( aPle )
        if "##WALD_TEST" == fields[0]:
            wald = WALD()
            wald.score = fields[1]
            wald.df = fields[2]
            wald.p = fields[3]
        if "##EWALD_TEST" == fields[0]:
            ewald = WALD()
            ewald.score = fields[1]
            ewald.df = fields[2]
            ewald.p = fields[3]
    return ( ples, wald, robusts, ewald )         
    

def ParseCoxrData( filepath ):
    f = open( filepath )
    lines = f.readlines()
    f.close()

    coxr_data = {}
    data = []

    fields = lines[0].split( "\t" )
    time = fields[0]
    data.append( [] )

    status = fields[1]
    data.append( [] )

    keys = []
    i = 2
    for field in fields[2:]:
        keys.append( field.strip() )
        data.append( [] )
        i += 1

    for line in lines[1:]:
        fields = line.split( "\t" )
        for j in range( 0, i ):
            try:
                data[ j ].append( float( fields[j] ) )
            except:            
                data[ j ].append( float( "NaN" ) )

    coxr_data[ "time" ] = data[0]  
    coxr_data[ "status" ] = data[1]

    for j in range( 2, i ):  
        coxr_data[ keys[j-2] ] = data[j]  

    return coxr_data, keys


